From 9643703a3f4ca52f51e6b34299181c203ae4300d Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 27 2020 20:04:01 +0000
Subject: [PATCH 1795/2232] Generate sizeof and alignof symbols


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 96cd15a..69c90eb 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -55,7 +55,10 @@ fn expand(ffi: Module, apis: &[Api], types: &Types) -> TokenStream {
             Api::CxxFunction(efn) => {
                 expanded.extend(expand_cxx_function_shim(efn, types));
             }
-            Api::RustType(ety) => expanded.extend(expand_rust_type_impl(ety)),
+            Api::RustType(ety) => {
+                expanded.extend(expand_rust_type_impl(ety));
+                hidden.extend(expand_rust_type_layout(ety));
+            }
             Api::RustFunction(efn) => hidden.extend(expand_rust_function_shim(efn, types)),
             Api::TypeAlias(alias) => {
                 expanded.extend(expand_type_alias(alias));
@@ -681,6 +684,30 @@ fn expand_rust_type_assert_sized(ety: &ExternType) -> TokenStream {
     }
 }
 
+fn expand_rust_type_layout(ety: &ExternType) -> TokenStream {
+    let ident = &ety.name.rust;
+    let span = ident.span();
+
+    let link_sizeof = mangle::operator(&ety.name, "sizeof");
+    let link_alignof = mangle::operator(&ety.name, "alignof");
+
+    let local_sizeof = format_ident!("__sizeof_{}", ety.name.rust);
+    let local_alignof = format_ident!("__alignof_{}", ety.name.rust);
+
+    quote_spanned! {span=>
+        #[doc(hidden)]
+        #[export_name = #link_sizeof]
+        extern "C" fn #local_sizeof() -> usize {
+            ::std::mem::size_of::<#ident>()
+        }
+        #[doc(hidden)]
+        #[export_name = #link_alignof]
+        extern "C" fn #local_alignof() -> usize {
+            ::std::mem::align_of::<#ident>()
+        }
+    }
+}
+
 fn expand_rust_function_shim(efn: &ExternFn, types: &Types) -> TokenStream {
     let link_name = mangle::extern_fn(efn, types);
     let local_name = match &efn.receiver {
diff --git a/tests/ui/opaque_not_sized.stderr b/tests/ui/opaque_not_sized.stderr
index 9818e44..75773b6 100644
--- a/tests/ui/opaque_not_sized.stderr
+++ b/tests/ui/opaque_not_sized.stderr
@@ -9,3 +9,21 @@ error[E0277]: the size for values of type `str` cannot be known at compilation t
   |
   = help: within `TypeR`, the trait `Sized` is not implemented for `str`
   = note: required because it appears within the type `TypeR`
+
+error[E0277]: the size for values of type `str` cannot be known at compilation time
+   --> $DIR/opaque_not_sized.rs:4:14
+    |
+4   |         type TypeR;
+    |              ^^^^^ doesn't have a size known at compile-time
+    |
+    = help: within `TypeR`, the trait `Sized` is not implemented for `str`
+    = note: required because it appears within the type `TypeR`
+
+error[E0277]: the size for values of type `str` cannot be known at compilation time
+   --> $DIR/opaque_not_sized.rs:4:14
+    |
+4   |         type TypeR;
+    |              ^^^^^ doesn't have a size known at compile-time
+    |
+    = help: within `TypeR`, the trait `Sized` is not implemented for `str`
+    = note: required because it appears within the type `TypeR`

